c     Aquest arxiu llegeix l'arxiu de dades de l'observatori Fabra, que dna
c     l'instant de bolcament de la cassoleta de 0.1 mm en el format segent:
c
c     dia mes any hora minut segon dcima
c
c     El resultat s un fitxer on cada succs de pluja s una lnia aix:
c
c     Instant_inici(dd mm aaaa hh mm) Duraci Precipitaci Pluviograma_acumulat_normalitzat_(resoluci: 10 intervals)
      
      character*8 filename
   
      integer*4 dia1,dia2,mes1,mes2,any1,any2,hora1,hora2,min1,min2,sec1
     .          ,sec2,diesmesos,t1,t2,delta_t,delta_t0,
     .          dia0,mes0,any0,hora0,min0,t_llindar,delta_tmax,diesmes,
     .          dsec1,dsec2
      real*8 pluviograma,p_acum,p_llindar,i_max,i_llindar,perdues,forma,
     .       tk,i_interv,duracio_dsec,duracio_h,imm,imm_max,tr,tr_max       
           
      dimension diesmesos(12),pluviograma(2,11520),forma(101),
     .          imm(24),tr(24) 
      
c_____La variable diesmesos serveix per la funci externa "diesmes"
      diesmesos(1)=31
      diesmesos(2)=0
      diesmesos(3)=31
      diesmesos(4)=30
      diesmesos(5)=31
      diesmesos(6)=30
      diesmesos(7)=31
      diesmesos(8)=31
      diesmesos(9)=30
      diesmesos(10)=31
      diesmesos(11)=30
      diesmesos(12)=31
      

c_____Lectura dels parmetres del programa  
      open(unit=40,file='fabra40.par',status='old')      
      
c_____Temps mxim entre dos bolcaments per considerar-los dins el mateix
c_____succs de pluja (en dcimes de segon)
c_____ATENCI: aquest valor no pot superar 28 dies (en cas contrari, el 
c_____clcul del temps entre instants de bolcament no ser correcte.
      read(40,*) delta_tmax
      delta_tmax=delta_tmax*600 
      
c_____Llindars de duraci (en dcimes de segon), precipitaci (en mm) i 
c_____intensitat (en mm/h) per tal d'enregistrar el succs de pluja
      read(40,*) t_llindar
      t_llindar=t_llindar*600
      read(40,*) p_llindar
      read(40,*) i_llindar
      
c_____Lectura del nmero d'intervals del pluviograma
      read(40,*) n_interv     

c_____Lectura de la intensitat llindar (funci de prdues)
      read(40,*) perdues
      
      close(40)
      
      
      nsuccessos_ok=0
      nsuccessos=0
      not_imin=0
      not_pmin=0
      not_tmin=0
                
c_____Obertura dels fitxer de dades, resultats i missatges del programa                                
      open(unit=10,file='c:/f32/daniel/tesina/dades/fabra/fabra.dat',
     .status='old')
c_____ATENCI: l'ltima lnia del fitxer de dades ha de ser -1 0 0 0 0 0 0
      open(unit=20,file='fabra40.res',status='unknown')
      open(unit=30,file='fabra40.err',status='unknown')
      open(unit=50,file='arxius.txt',status='old')
      
      write (20,200) 'Dia','Mes','Any','Hora','Minut','Duracio(h)',
     .               'Precip(mm)','IMM_5(mm/h)','TRmax(anys)',
     .               'Interv(min)',(5*i,i=1,24),(5*i,i=1,24),
     .               (0.01*float(i),i=0,n_interv)      
                           
      read(10,*) dia2,mes2,any2,hora2,min2,sec2,dsec2
      
      write (6,*) 'Programa iniciant-se normalment'
      
c_____Bucle de successos: cada cop que es reinicia aquest bucle es tracta
c_____d'un nou succs de pluja
   50 do while(dia2.ne.(-1))
      
c_________Inicialitzaci de les variables del succs
          t2=0
c_________La precipitaci s'inicia a -.1 pq el primer pas del bucle s 
c_________sumar els 0.1 mm corresponents a cada bolcament
          p_acum=-0.1
          i=0
          i_max=0.
          dia0 = dia2
          mes0 = mes2
          any0 = any2    
          hora0 = hora2
          min0 = min2
          delta_t = 0
          delta_t0 = 0

c_________Bucle d'instants de bolcament dins de cada succs                    
          do while ((dia2.ne.(-1)).and.
     .              (delta_t.lt.delta_tmax).and.
     .              (delta_t0.lt.delta_tmax))


c_______________Actualitzaci de l'instant                
                i=i+1
                p_acum = max(0. , p_acum ,
     .                       p_acum + 0.1 - perdues *
     .                       dfloat(delta_t)/(60.*60.*10.))
                t1 = t2
                dia1 = dia2
                mes1 = mes2
                any1 = any2    
                hora1 = hora2
                min1 = min2
                sec1 = sec2
                dsec1 = dsec2
                pluviograma(1,i) = dfloat(t1)
                pluviograma(2,i) = p_acum     
                
                read(10,*) dia2,mes2,any2,hora2,min2,sec2,dsec2
                if (any2.ne.any1) write (6,*) any1
                
c_______________Clcul de l'interval de temps entre bolcaments
c_______________HIPTESI: delta_tmax < 1 mes
                delta_t = mes2 - mes1
          
                if (delta_t.lt.0) then
                    delta_t = delta_t + 12
                endif
                
                delta_t =  delta_t * diesmes(mes1,any1,diesmesos)
                delta_t = (delta_t + (dia2-dia1))*24
                delta_t = (delta_t + (hora2-hora1))*60
                delta_t = (delta_t + (min2-min1))*60
                delta_t = (delta_t + (sec2-sec1))*10
                delta_t =  delta_t + (dsec2-dsec1)

c_______________Actualitzaci de la intensitat mxima
                i_interv = 0.1*60.*60.*10./dfloat(delta_t) - perdues               
                i_max = max(i_max,i_interv)
                
c_______________Si les prudes sn superiors a la precipitaci,
c_______________tornem a iniciar el succs

                if (i_max.eq.(0.)) goto 50
                
c_______________Actualitzaci de l'instant de temps
                t2 = t1 + delta_t

c_______________Actualitzaci del perode amb intensitat < perdues
                if (i_interv.gt.(0.)) then
                   delta_t0 = 0
                else
                   delta_t0 = delta_t0 + delta_t
                endif
                
          enddo
          
          nsuccessos = nsuccessos + 1
          
c_________Corregim l'instant final del succs de pluja          
          if (delta_t0.ne.0) then
             t1 = t2 - delta_t0
          endif 

c_________Si el succs supera els llindars de precipitaci, temps i 
c_________intensitat, s'anota a l'arxiu de resultats          
          if ((t1.ge.t_llindar).and.(imm(1).ge.i_llindar).and.
     .       (p_acum.ge.p_llindar)) then                           

             m=1
             forma(1)=0
             forma(n_interv+1)=1
             do k=1,n_interv-1       
             
                tk=dfloat(t1*k)/dfloat(n_interv)
                do while (pluviograma(1,m).lt.tk)
                   m = m+1
                enddo
                forma(k+1)=(pluviograma(2,m-1) + (tk-pluviograma(1,m-1))
     .                     *(pluviograma(2,m)-pluviograma(2,m-1))/
     .                     (pluviograma(1,m)-pluviograma(1,m-1)))/p_acum
             enddo
             
             duracio_dsec = dfloat(t1)
             duracio_h = duracio_dsec/36000.
             
             call imm_tr(duracio_dsec,p_acum,pluviograma,imm,imm_max,tr,
     .                   tr_max,interv_max)

             if ((interv_max.le.(15)).and.(tr_max.ge.(1.))) then

                read (50,*) filename
                open (unit=60,file=filename,status='unknown')
                mm=1
                do while (mm.le.i)
             
                   write (60,666) pluviograma(1,mm)/600.
                   mm=mm+1
  
  555 format(a8)  
  666 format(f10.3)
              
                enddo   
                close(60)
                
             endif
              
             write (20,100) dia0,mes0,any0,hora0,min0,duracio_h,
     .                      p_acum,imm_max,tr_max,interv_max,
     .                      (imm(i),i=1,24),(tr(i),i=1,24),
     .                      (forma(j),j=1,n_interv+1)  
     
  100 format(1x,2(i2,2x),i4,2(4x,i2),2x,3(f10.6,2x),1x,f10.6,10x,i3,  
     .      48(2x,f10.6),2x,101(f10.6,2x))
  200 format(a3,1x,a3,3x,a3,2x,a4,1x,a5,2(2x,a10),1x,2(a11,2x),a11,     
     .       48(9x,i3),2x,101(f10.6,2x))
             
c____________Es comptabilitza el succs
             nsuccessos_ok = nsuccessos_ok + 1

c_________En cas contrari s'apunta per quin(s) criteri(s) s'ha descartat              
          else
              
             if (t1.lt.t_llindar) not_tmin=not_tmin+1
             if (p_acum.lt.p_llindar) not_pmin=not_pmin+1
             if (imm(1).lt.i_llindar) not_imin=not_imin+1
              
          endif
      
      enddo                                          
      
      
      close(10)
      close(20)
      close(50)
      
      write (30,*) 'Successos totals detectats:',nsuccessos
      write (30,*) 'Successos de duracio insuficient:',not_tmin
      write (30,*) 'Successos de precipitacio insuficient:',not_pmin
      write (30,*) 'Successos de intensitat insuficient:',not_imin
      write (30,*) 'Successos valids detectats:',nsuccessos_ok      
      
      write (30,*) 'Programa completat normalment'
      
      close(30)
     
      
      write (6,*) 'Programa completat normalment'
      
      
      stop
      end                                  
      
        
                                                                    
                                                                    
                                                                    
c_____**************************************************************
c_____***************** Funcions i subrutines **********************
c_____**************************************************************

        
      
c_____La funci 'diesmes' retorna el nmero de dies d'un mes
c_____(tenint en compte febrer en els anys de trasps)
c_____HIPTESI: 1901 < any < 2099       
      integer*4 function diesmes(mes,any,diesmesos)
      
      integer*4 mes,any,any4,any_res,diesmesos
      dimension diesmesos(12)
      
      if (mes.ne.2) then
          diesmes = diesmesos(mes)
      else
          any4=any/4
          any_res=any-4*any4
          if (any_res.eq.0) then
              diesmes=29
          else
              diesmes=28
          endif
      endif
      
      end
      
      
      
c_____La subrutina 'imm_tr' retorna, per un succs de pluja
c_____donat, les Intensitats Mitjanes Mximes (IMM) corresponents
c_____als intervals 5, 10, 15..., 120 minuts, aix com els perodes
c_____de retorn associats a aquestes intensitats (segons l'expressi
c_____proposada pels tcnics de CLABSA). Ambdues magnituds es
c_____donen com a fracci del valor mxim. Tamb es donen els valors
c_____mxims en termes absoluts i l'interval al que correspon tr_max.
      subroutine imm_tr(duracio_dsec,p_acum,pluviograma,imm,imm_max,
     .                  tr,tr_max,interv_max)
      
      real*8 duracio_dsec,p_acum,pluviograma,imm,tr,tr_max,
     .       imm_max, 
     .       d_min,d_dsec,t1,t2,p1,p2,im,dt1,dt2,a,b,c
     
      dimension pluviograma(2,11520),imm(24),tr(24)
      
c_____Inicialitzaci de variables
      imm_max=0.
      tr_max=0.
      interv_max=0            
      
c_____Bucle en duracions (5,10,15... 120)
      do k=1,24
      
         d_min=dfloat(5*k)
         d_dsec=d_min*600.   
         
         if (d_dsec.ge.duracio_dsec) then
c_____Si la duraci de la pluja s menor que l'interval, no hi ha clcul:
c_____es calcula la intensitat mitjana suposant que noms plou durant el
c_____succs considerat
            imm(k)=p_acum/(d_min/60.)
      
         else
c_____Si la duraci de la pluja s major que l'interval, cal
c_____calcular quin dels subintervals presenta la IMM.

c___________Inicialitzaci de les variables (1r subinterval)     
            imm(k)=0.
            i=1
            j=1            
            do while (pluviograma(1,j).lt.d_dsec)
               j=j+1            
            enddo            
            t1=0.
            t2=d_dsec                    
            
c___________Bucle per trobar la IMM.            
            do while (t2.lt.duracio_dsec)     
            
c______________Actualitzaci de la IMM
               p1=pluviograma(2,i)+0.1*(t1-pluviograma(1,i))/
     .            max((pluviograma(1,i+1)-pluviograma(1,i)),1)
               p2=pluviograma(2,j-1)+0.1*(t2-pluviograma(1,j-1))/
     .            max((pluviograma(1,j)-pluviograma(1,j-1)),1)
               im=(p2-p1)/(d_min/60.)
               imm(k)=max(imm(k),im)
               
c______________Canvi de subinterval
               dt1=pluviograma(1,i+1)-t1
               dt2=pluviograma(1,j)-t2
               if (dt1.lt.dt2) then
                  i=i+1
                  t1=pluviograma(1,i)
                  t2=t1+d_dsec
               else
                  j=j+1
                  t2=pluviograma(1,j-1)
                  t1=t2-d_dsec
               endif               
     
            enddo
      
         endif
      
c________Clcul del perode de retorn associat a la IMM obtinguda
         a=-78.1590*exp(-0.0396*d_min)
         b=9889.0068*((d_min+17.3611)**(-1.2395)) 
         c=0.0023*d_min+0.3027
         tr(k)=-1.+exp(((imm(k)-a)/b)**(1./c))
         
c________Actualitzaci dels valors mxims
         imm_max=max(imm_max,imm(k))
         if (tr(k).gt.tr_max) then
            tr_max=tr(k)
            interv_max=5*k
         endif            
         
      enddo               
      
c_____Normalitzaci de IMM i TR
      do k=1,24
         imm(k)=imm(k)/imm_max
         tr(k)=tr(k)/tr_max
      enddo           
        

      return
      end
